package tests;

import java.io.File;
import java.io.IOException;

import org.junit.Before;
import org.junit.Test;

import classes.HolonObject;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import ui.controller.CanvasController;
import ui.controller.CategoryController;
import ui.controller.LoadController;
import ui.controller.MultiPurposeController;
import ui.controller.ObjectController;
import ui.controller.StoreController;
import ui.model.Model;

public class praktikumHolonsTestLoadAndStoreController {

	protected praktikumHolonsAdapter adapter;
	protected Model model;
	protected MultiPurposeController mp;
	protected CategoryController cg;
	protected CanvasController cvs;
	protected ObjectController obj;
	protected StoreController storeController;
	protected LoadController loadController;
	protected String path = System.getProperty("user.home") + "/HolonGUI/Test/";
	
	
	@Before
	public void setUp() {
		adapter = new praktikumHolonsAdapter();
		model = new Model();
		mp = new MultiPurposeController(model);
		cg = new CategoryController(model, mp);
		cvs = new CanvasController(model, mp);
		obj = new ObjectController(model, mp);
		storeController = new StoreController(model);
		loadController = new LoadController(model, cg, cvs, obj, mp);
		File file = new File(path);
		file.mkdirs();
	}
	
	@Test
	public void testStoreMinimal(){
		cg.initCategories();
		obj.initHolonElements();
		try {
			File sav = new File(path + "TestSavMinimal.json");
			storeController.writeSaveFile(sav.getAbsolutePath());
			assertTrue("Save File was not created", new File(path + "TestSavMinimal.json").exists());
			
			File cat = new File(path + "TestCatMinimal.json");
			storeController.writeCategoryFile(cat.getAbsolutePath());
			assertTrue("Category File was not created", new File(path + "TestCatMinimal.json").exists());
			
			File canvas = new File(path + "TestCanvasMinimal.json");
			storeController.writeCanvasFile(canvas.getAbsolutePath());
			assertTrue("Canvas File was not created", new File(path + "TestCanvasMinimal.json").exists());
			
			assertTrue("Non Existant File exist", !new File(path + "TestDummyMinimal.json").exists());
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	@Test
	public void testStoreCanvas() {
		for (int i = 1; i < 11; i++) {
			cvs.addNewObject(new HolonObject(adapter.generate(i)));
			assertTrue("Size of Objects on Canvas does not match", model.getObjectsOnCanvas().size() == i);
			assertTrue("Object was not created", mp.searchByID(i) != null && mp.searchByID(i).getObjName().equals(adapter.generate(i)));
		}
	}
}
